Leetcode 300. Longest Increasing Subsequence

来源:互联网 发布:linux服务器架构 编辑:程序博客网 时间:2024/06/06 09:02

-题目-
Given an unsorted array of integers, find the length of longest increasing subsequence.
For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.
Your algorithm should run in O(n2) complexity.
Follow up: Could you improve it to O(n log n) time complexity?
题目的意思就是让我们找一个数组的最长递增子序列(可以不连续)。

-思路1-
O(n^2)的算法其实还挺好想,就是对遍历整个数组,对于元素i,它对应的的最大子序列的个数是由它前面比它小的元素的最大子序列个数决定的。也就是说状态转移方程为dp[i] = max(dp[i], dp[k]+1),其中nums[k]小于nums[i]。

-代码1-

class Solution {public:    int lengthOfLIS(vector<int>& nums) {        if(nums.size() == 0) return 0;         vector<int> dp(nums.size(), 1);         int cur_max = 1;         for(int i = 1; i < nums.size(); i++) {            for(int j = 0; j < i; j++) {                if(nums[j] < nums[i]) {                    dp[i] = max(dp[i], dp[j]+1);                 }            }            cur_max = max(cur_max, dp[i]);             cout << "i: " << i << " " << dp[i] << endl;         }        return cur_max;     }};

-思路2-
参考了一下网上的思路,O(nlogn)的算法感觉上也是很好理解的,大致就是一个替换不改变当前数组大小,因此数组中大元素越少越好的思想。
用一个dp向量保存最长序列数组,然后遍历数组,如果:
1.当前数组元素大于向量中最大元素值,直接插入到向量末尾(向量末尾存储的永远是最大值)
2.如果数组元素小于向量中最大元素值,遍历向量遇见第一个比它大的元素的时候,替换之。

-代码2-

class Solution {public:    int lengthOfLIS(vector<int>& nums) {        if(nums.size() == 0) return 0;         vector<int> dp;         dp.push_back(nums[0]);         for(int i = 1; i < nums.size(); i++) {            if(nums[i] > dp.back()) dp.push_back(nums[i]);             else {                for(int j = 0; j < dp.size(); j++) {                    if(nums[i] == dp[j]) break;                     if(nums[i] < dp[j]) {                        dp[j] = nums[i]; break;                     }                }            }        }       return dp.size();     }};
0 0
原创粉丝点击